/**
 * JS Document.
 * @author Sandro Jordão.
 */
 
function gravar()
{
	$.post(basepath + 'principal/verificarLogado', 
		function(logado) {
			if(logado == 0)
			{
				//
				var nome = $("#txtNome").val();
				var descricao = $("#txtDescricao").val();
				var groupArray = new Array();
				$(".groups").each(function(){ groupArray.push($(this).val()); });
				var usersArray = new Array();
				$(".users").each(function(){ usersArray.push($(this).val()); });
				var tema = $.trim($("#temaDashboard").val());
				var fundo = ($("#backgroundDashboard").is(':checked')) ? 'T' : 'F';
				
				var clonar = $("#txtDashboardID").val();

				$('.msgErro').remove();
				var erro = 0;
				
				if(nome == '')
				{
					$('#txtNome').after("<span class='msgErro'> Campo de preenchimento obrigatório. </span>");
					erro++;
				}

				if (erro == 0)
				{
					$.post(basepath + "cadastros/gravaDashboards", {
						nome : nome,
						clonar : clonar,
						descricao : descricao,
						tema : tema,
						fundo : fundo,
						'grupos[]' : groupArray,
						'usuarios[]' : usersArray
					}, function(data){
						if(data == 1)
						{
							jAlert('Dashboard cadastrado com sucesso!', 'Alerta!', function() { window.location.href = basepath + 'principal/dashboard'; });
						}
						else 
						{
							jAlert('Ocorreu um erro:\n ' + data, 'Alerta!');
						}
					});
				}
				else
				{
					jAlert('Favor preencher todos os campos corretamente.', 'Alerta!');
				}
				//
			}
			else
			{
				window.location.href = basepath + 'principal/' + logado;
			}
		});
}

function alterarBD()
{
	$.post(basepath + 'principal/verificarLogado', 
		function(logado) {
			if(logado == 0)
			{
				//		
				var dashboard = $("#txtDashboardID").val();
				var nome = $("#txtNome").val();
				var descricao = $("#txtDescricao").val();
				var groupArray = new Array();
				$(".groups").each(function(){ groupArray.push($(this).val()); });
				var usersArray = new Array();
				$(".users").each(function(){ usersArray.push($(this).val()); });
				var tema = $.trim($("#temaDashboard").val());
				var fundo = ($("#backgroundDashboard").is(':checked')) ? 'T' : 'F';

				$('.msgErro').remove();
				var erro = 0;
				
				if(nome == '')
				{
					$('#txtNome').after("<span class='msgErro'> Campo de preenchimento obrigatório. </span>");
					erro++;
				}

				if (erro == 0)
				{
					$.post(basepath + "cadastros/alterarDashboardBD", {
						dashboard : dashboard,
						nome : nome,
						descricao : descricao,
						tema : tema,
						fundo : fundo,
						'grupos[]' : groupArray,
						'usuarios[]' : usersArray
					}, function(data){
						if(data == 1)
						{
							jAlert('Dashboard alterado com sucesso!', 'Alerta!', function() { window.location.href = basepath + 'principal/dashboard'; });
						}
						else alert('Ocorreu um erro:\n ' + data);
					});
				}
				else
				{
					jAlert('Favor preencher todos os campos corretamente.', 'Alerta!');
				}
				//
			}
			else
			{
				window.location.href = basepath + 'principal/' + logado;
			}
		});
}

function voltar()
{
	window.location.href = basepath + 'principal/dashboard';
}

/*
function incluir()
{
	window.location.href = basepath + 'cadastros/caddashboards';
}

function alterar()
{
	var dashboard = $('#gridDashboards').jqGrid('getGridParam','selrow');

    if(dashboard) {
		window.location.href = basepath + 'cadastros/alterarDashboard/' + dashboard;
	} else {
		jAlert('Selecionar um Dashboard para alteração!', 'Alerta!', function() { return false; });
	}
}
*/

/*
function excluir()
{
	var dashboard = $('#gridDashboards').jqGrid('getGridParam','selrow');

    if(dashboard)
	{
		jConfirm("Deseja realmente excluir o Dashboard?", 'Confirmação!',
        function(r) {
            if (r == true)
            {
                $.post(basepath + "cadastros/excluirDashboard", {
                    dashboard  : dashboard
                }, function(data){
                    if(data == 1)
                    {
                        $("#gridDashboards").trigger("reloadGrid");
                        
                        jAlert('Dashboard excluído com sucesso!', 'Alerta!');
                    }
                    else jAlert('Ocorreu um erro:\n ' + data, 'Alerta de erro!');
                });
            }
            else
            {
                return false;
            }
        });
	}
    else
	{
		jAlert('Selecionar um Dashboard para exclusão!', 'Alerta!', function() { return false; });
	}
}
*/

/*
function buscaDashboard()
{
	var dashboard = $("#comboDashboard").val();
	
	if(dashboard != '')
	{	
		$("#comboDashboard").after('<img src="' + basepath + 'www/imagem/loadingModal.gif" class="imgLoading" align="absmiddle" />');
		
		$.post(basepath + "cadastros/buscaDadosDashboard", {
			dashboard : dashboard
		}, function(data) {
			dados = eval('(' + data + ')'); 
			$("#txtNome").val(dados.nome);
			$("#txtDescricao").val(dados.descricao);
			$(".groupsList").html(dados.grupos);
			$(".usersList").html(dados.usuarios);
			$(".imgLoading").remove();
			
			$(".users").click(desabilitaRemoverUser);
			$(".groups").click(desabilitaRemoverGroup);
		});
	}
	else
	{
		$("#txtNome").val("");
		$("#txtDescricao").val("");
		$(".groupsList, .usersList").html("");
		
		return false;
	}
}
*/
/*
function msn()
{
	if($('#procurarGrupo').val() == '')
	{
		$('#procurarGrupo').val('Pesquisar grupos...');
		$('#procurarGrupo').removeClass('inputProcurarOff').addClass('inputProcurarOn');
	}
	
	if($('#procurarUsuario').val() == '')
	{
		$('#procurarUsuario').val('Pesquisar usuários...');
		$('#procurarUsuario').removeClass('inputProcurarOff').addClass('inputProcurarOn');
	}
}

function limpar()
{
	if($('#procurarGrupo').val() == 'Pesquisar grupos...')
	{
		$('#procurarGrupo').val('');
		$('#procurarGrupo').removeClass('inputProcurarOn').addClass('inputProcurarOff');
	}
	
	if($('#procurarUsuario').val() == 'Pesquisar usuários...')
	{
		$('#procurarUsuario').val('');
		$('#procurarUsuario').removeClass('inputProcurarOn').addClass('inputProcurarOff');
	}
}

function procurarGrupo()
{
	var valor = $.trim($("#procurarGrupo").val());
	
	if(valor == 'Pesquisar grupos...') valor = '';
	
	if(valor.length > 2 || valor == '')
	{
		$("#btn_procurar").hide();
		$("#loadingModal").show();

		$.post(basepath + "cadastros/procurarGrupos", {
			valor : valor
		}, function(data) {
			$(".modalList").html(data);
			$(".groups").each(function(){ $("#group" + this.id).parent().parent().remove(); });
			$("#loadingModal").hide();
			$("#btn_procurar").show();
		});
	}
}

function procurarUsuario()
{
	var valor = $.trim($("#procurarUsuario").val());
	
	if(valor == 'Pesquisar usuários...') valor = '';
	
	if(valor.length > 2 || valor == '')
	{
		$("#btn_procurar").hide();
		$("#loadingModal").show();

		$.post(basepath + "cadastros/procurarUsuarios", {
			valor : valor
		}, function(data) {
			$(".modalList").html(data);
			$(".users").each(function(){ $("#user_" + this.id).parent().parent().remove(); });
			$("#loadingModal").hide();
			$("#btn_procurar").show();
		});
	}
}

function checkUsers()
{
	var uChecked = $("#user_all").is(':checked');
	$(".usersCheckbox").attr('checked', uChecked);
}

function checkGroups()
{
	var uChecked = $("#group_all").is(':checked');
	$(".groupsCheckbox").attr('checked', uChecked);
}
*/
/*
function buscaDadosDashboard()
{
	var opcao = $('input[name=rdoDashboard]:radio:checked').val();
	
	if(opcao == 'E')
		$("#comboDashboard").removeAttr("disabled");
	else
	{
		$("#comboDashboard").attr("disabled", true).val("");
		
		$("#txtNome").val("");
		$("#txtDescricao").val("");
		$(".groupsList, .usersList").html("");
	}
}
*/
/*
function adicionarGrupo()
{
	$.post(basepath + "cadastros/adicionarGrupo", { }, function(data){
	
		$("#janela_modal").html('');
		$("#overlay").html('');
		
		var overlay = '<div id="overlay"></div>';
		var overlayCSS = {'width' : pageWidth + 'px','height' : pageHeight + 'px'};
		
		var janela = '<div id="janela_modal"></div>';
		var janelaCSS = {'top' : '50%','left' : '50%','width' : '500px','height' : '350px','margin-left' : '-250px','margin-top' : '-175px'};
		
		var btnFechar = '<a onClick="fechar()"><img id="btnFechar" src="' + basepath + 'www/imagem/close.png" alt="Fechar" title="Fechar" /></a>';
		var btnFecharCSS = {'position' : 'absolute','top' : '50%','left' : '50%','cursor' : 'pointer','margin-left' : '225px','margin-top' : '-180px'}
		
		var btnCancelar = '<input type="image" id="btn_cancelar" name="btn_cancelar" src="' + basepath + 'www/imagem/btn_cancelar.png" onClick="fechar()" />';
		var btnCancelaCSS = {'position' : 'absolute','top' : '100%','left' : '100%','margin-left' : '-115px','margin-top' : '-45px','width' : '100px'}
		
		var btnOK = '<input type="image" id="btn_enviar" name="btn_enviar" src="' + basepath + 'www/imagem/btn_ok.png" onClick="adicionarGrupos()" />';
		var btnOKCSS = {'position' : 'absolute','top' : '100%','left' : '0%','margin-left' : '300px','margin-top' : '-45px','width' : '100px'}
		
		$("body").append(overlay);
		$("body").append(janela);
		$("#overlay").css(overlayCSS).fadeIn('slow', function(){
			
			$("#janela_modal").append(data);
			
			$("#janela_modal").append(btnFechar);
			$("#btnFechar").css(btnFecharCSS).fadeIn("slow");
			
			$("#janela_modal").append(btnCancelar);
			$("#btn_cancelar").css(btnCancelaCSS);
			
			$("#janela_modal").append(btnOK);
			$("#btn_enviar").css(btnOKCSS);
			
			$("#janela_modal").css(janelaCSS).fadeIn("slow");
			
			$(".groups").each(function(){ $("#group" + this.id).parent().parent().remove(); });
			
			$('#procurarGrupo').keyup(procurarGrupo);
		});
		
		return false;
	});
}

function adicionarGrupos()
{
	var groups = new Array();
	var count = 0;
	
	$(".groupsCheckbox:checked").each(function(){
		groups.push($(this).val());
		count++;
	});
	
	$(".groups").each(function(){
		groups.push($(this).val());
		count++;
	});

	if(count > 0)
	{
		$.post(basepath + "cadastros/montarHtmlGrupos", {
			"grupos[]" : groups
		}, function(data) {
			$(".groupsList").html(data);
			$(".groups").click(desabilitaRemoverGroup);
			fechar();
		});
	}
	else
		fechar();
}

function adicionarUsuario()
{
	$.post(basepath + "cadastros/adicionarUsuario", { }, function(data) {
	
		$("#janela_modal").html('');
		$("#overlay").html('');
		
		var overlay = '<div id="overlay"></div>';
		var overlayCSS = {'width' : pageWidth + 'px','height' : pageHeight + 'px'};
		
		var janela = '<div id="janela_modal"></div>';
		var janelaCSS = {'top' : '50%','left' : '50%','width' : '500px','height' : '350px','margin-left' : '-250px','margin-top' : '-175px'};
		
		var btnFechar = '<a onClick="fechar()"><img id="btnFechar" src="' + basepath + 'www/imagem/close.png" alt="Fechar" title="Fechar" /></a>';
		var btnFecharCSS = {'position' : 'absolute','top' : '50%','left' : '50%','cursor' : 'pointer','margin-left' : '225px','margin-top' : '-180px'}
		
		var btnCancelar = '<input type="image" id="btn_cancelar" name="btn_cancelar" src="' + basepath + 'www/imagem/btn_cancelar.png" onClick="fechar()" />';
		var btnCancelaCSS = {'position' : 'absolute','top' : '100%','left' : '100%','margin-left' : '-115px','margin-top' : '-45px','width' : '100px'}
		
		var btnOK = '<input type="image" id="btn_enviar" name="btn_enviar" src="' + basepath + 'www/imagem/btn_ok.png" onClick="adicionarUsuarios()" />';
		var btnOKCSS = {'position' : 'absolute','top' : '100%','left' : '0%','margin-left' : '300px','margin-top' : '-45px','width' : '100px'}
		
		$("body").append(overlay);
		$("body").append(janela);
		$("#overlay").css(overlayCSS).fadeIn('slow', function(){
			
			$("#janela_modal").append(data);
			
			$("#janela_modal").append(btnFechar);
			$("#btnFechar").css(btnFecharCSS).fadeIn("slow");
			
			$("#janela_modal").append(btnCancelar);
			$("#btn_cancelar").css(btnCancelaCSS);
			
			$("#janela_modal").append(btnOK);
			$("#btn_enviar").css(btnOKCSS);
			
			$("#janela_modal").css(janelaCSS).fadeIn("slow");
			
			$(".users").each(function(){ $("#user_" + this.id).parent().parent().remove(); });
			
			$('#procurarUsuario').keyup(procurarUsuario);
		});
		
		return false;
	});
}

function adicionarUsuarios()
{
	var users = new Array();
	var count = 0;
	
	$(".usersCheckbox:checked").each(function(){
		users.push($(this).val());
		count++;
	});
	
	$(".users").each(function(){
		users.push($(this).val());
		count++;
	});

	if(count > 0)
	{
		$.post(basepath + "cadastros/montarHtmlUsuarios", {
			"usuarios[]" : users
		}, function(data) {
			$(".usersList").html(data);
			$(".users").click(desabilitaRemoverUser);
			fechar();
		});
	}
	else
		fechar();
}

function fechar() 
{
    $("#janela_modal").fadeOut();
    $("#overlay").fadeOut();
}

function removerGrupo()
{
    $(".groups:checked").each(function() {
        $(this).parent().parent().remove();
    });

    desabilitaRemoverGroup();
}

function removerUsuario()
{
	$(".users:checked").each(function() {
		$(this).parent().parent().remove();
	});
	
	desabilitaRemoverUser();
}

function desabilitaRemoverUser()
{
	var count = 0;
	$(".users:checked").each(function(){ count++; });
	if(count == 0) 
		$("#btnRemoverUser").attr("disabled", true); 
	else
		$("#btnRemoverUser").removeAttr("disabled");
}

function desabilitaRemoverGroup()
{
	var count = 0;
	$(".groups:checked").each(function(){ count++; });
	if(count == 0) 
		$("#btnRemoverGroup").attr("disabled", true); 
	else
		$("#btnRemoverGroup").removeAttr("disabled");
}

function gerarDashboard(id, tipo)
{
	jConfirm("Deseja realmente incluir o relatório no dashboard?", 'Confirmação!',
		function(r) {
			if (r == true)
			{
				$.post(basepath + "principal/inserirDashboard", {
					relatorio : id
				}, function(data) {
					if (data == 1)
						window.location.href = basepath + 'principal/dashboard';
					else
						jAlert('Não foi possível incluir o relatório!', 'Alerta!');
				});
			}
			else
			{
				return false;
			}
		});
}
*/
function trocar()
{
	var aba = this.id;
	
	tabs.removeClass('inDetail');
	$(tabs[aba]).addClass('inDetail');
		
	divs.hide();
	$(divs[aba]).fadeIn('slow');
}

function previewTheme()
{
	var tema = $.trim($("#temaDashboard").val());
	var fundo = ($("#backgroundDashboard").is(':checked')) ? 'T' : 'F';
	
	$("#previewThemeDashboard").fadeOut('fast', function(){ $("#previewThemeDashboard").html(''); });
	
	$.post(basepath + "principal/visualizarTemasImg", {
		tema : tema,
		fundo : fundo
	}, function(data) {
		setTimeout(function(){ $("#previewThemeDashboard").html(data).fadeIn('slow'); }, 400);
	});
 	
// 	$.post(basepath + "principal/visualizarTemasDashboard/" + tema + "/" + fundo, 
// 	function(data) { 
// 		setTimeout(function(){ $("#previewThemeDashboard").html(data).fadeIn('slow'); }, 400);
// 	});
}

function init()
{
	pageWidth = $(window).width();
	pageHeight = $(window).height();
	
	var url = window.location;
	var urlString = url.toString();
	var urlArray = urlString.split("/");

	$('#menuContentLeft a').each(function() {
		if(url == $(this).attr("href")) {
			$(this).css({'color' : '#4084b8', 'font-weight' : 'bold'});
		}
	});
	
	tabs = $(".tabsDetail").children('ul').children();
	divs = $(".tabsDetail").children('div');
	$(".abaTrocar").click(trocar);
	
	$(".users").click(desabilitaRemoverUser);
	$(".groups").click(desabilitaRemoverGroup);

	var count = 0;
	$("#comboDashboard option").each(function() { count++ });
	if(count < 2)
	{
		$("#existeDashboard").attr("disabled", true);
		$("#comboDashboard, #lblExisteDashboard").css({'color' : '#999'});
	}
	
	previewTheme();
}

$(document).ready(init);